/*
Hijackulator - ZX Spectrum emulator with support for native-code enhancements
Copyright (C) 2003 Matthew Westcott

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Some portions of this software originate from the JEMU project:
http://jemu.emuunlim.com/
*/

/*
 * HoraceGoesSkiingHijack.java
 *
 * Created on 04 May 2003, 03:26
 */

package org.zxdemo.hijackulator;

import java.awt.*;
import java.applet.Applet;
import java.net.URL;

/**
 * Hijack definition for Horace Goes Skiing
 * @author  Matthew Westcott
 */
public class HoraceGoesSkiingHijack implements HijackDefinition {
    
    public Image giantBee = null;
    
    /** Creates a new instance of HoraceGoesSkiingHijack */
    public HoraceGoesSkiingHijack(Applet applet) {
        try {
            this.giantBee = applet.getImage(new URL(applet.getDocumentBase(), "giantbee.gif"));
        } catch (Exception e) {
            System.err.println("Oh no!" + e);
        }
    }
    
    public Trap[] getTraps() {
        Trap[] traps = {
            new Trap() {
                protected HijackDefinition parent = null;
                public void setParent(HijackDefinition p) {parent = p;}
                public int getAddress() {return 0x6c20;}
                public void hijack(Z80 proc, Speccy48Memory mem, SpeccyScreen screen) {
                    screen.pen = false;
                    int screenAddress =
                        (proc.getRegisterValue(proc.H) & 0xff) << 8
                        | (proc.getRegisterValue(proc.L) & 0xff);
                    Point horacePoint = screen.pointOfAddress(screenAddress);
                    horacePoint.y -= 8;
                    screen.g.drawImage(((HoraceGoesSkiingHijack)parent).giantBee,horacePoint.x << 1, horacePoint.y << 1, null);
                }
            },
            new Trap() {
                protected HijackDefinition parent = null;
                public void setParent(HijackDefinition p) {parent = p;}
                public int getAddress() {return 0x6c8a;}
                public void hijack(Z80 proc, Speccy48Memory mem, SpeccyScreen screen) {
                    screen.pen = true;
                }
            }            
        };
        return traps;
    }
    
}
