/*
Hijackulator - ZX Spectrum emulator with support for native-code enhancements
Copyright (C) 2003 Matthew Westcott

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Some portions of this software originate from the JEMU project:
http://jemu.emuunlim.com/
*/

/*
 * Trap.java
 *
 * Created on 04 May 2003, 03:11
 */

package org.zxdemo.hijackulator;

/**
 * Interface to define a single trap to 'escape' from the Spectrum code
 * @author  Matthew Westcott
 */
public interface Trap {
    
    // return the value of PC which will trigger this trap
    int getAddress();
    
    void setParent(HijackDefinition h);
    
    // perform the hijack action
    void hijack(Z80 z80, Speccy48Memory memory, SpeccyScreen screen);
    
}
